;	
;	framsp2a.s
;
;	P/ECE SPC Driver V2
;
;	CLiP - Common Library for P/ECE
;	Copyright (C) 2001-2004 Naoyuki Sawa
;
;	* Mon Oct 11 12:53:00 JST 2004 Naoyuki Sawa
;	- 쐬JnB
;
#include "clipsp2a.h"
#include "clipsp2b.h"
#ifdef SPC2_ASM

; * pɂɃANZXSPC2CPU\̂RAMɔzuāA}܂B
;   SPC2CPU\̂͏ΏۂȂ̂ŁA{.codeZNVɔzû͗ǂȂ̂łA
;   clip.mkɂ.codeZNVRAM֓]悤ɐݒ肵Ă̂ŁAdȂłB
;   P/ECE.code,.data,.bssSRAMɓWJĎŝŁA͖肠܂B
; * ̈.codeZNVɔzu邽߂ɁA.commł͂Ȃ.spacegĂ܂B
;   .commgƋI.bssZNVɔzuĂ܂̂ŁA_łB
	.code
	.align 2
	.global spc2cpu
spc2cpu:
	.space SPC2CPU_SIZE

	.code
	.align 1

;****************************************************************************
;	SPC2CPU
;****************************************************************************

	.global spc2cpu_run
spc2cpu_run:
	pushn %r3

	xld.w %r0, spc2cpu		; cpu = &spc2cpu
	xld.w %r1, [%r0+PC]		; PC = cpu->pc
	xld.w %r2, spc2cpu_TABLE	; spc2cpu_TABLE
	ld.w %r3, %r12			; count
	; %r0 = cpu
	; %r1 = PC
	; %r2 = spc2cpu_TABLE
	; %r3 = count

spc2cpu_run_L10:			; do {

;;{{SPC2_DEBUG
;;	pushn %r15
;;	xld.w %r0, [spc2cpu+PC]
;;	xld.w [spc2cpu+PC], %r1
;;	xcall spc2cpu_dump
;;	xld.w [spc2cpu+PC], %r0
;;	popn %r15
;;}}SPC2_DEBUG

	ld.ub %r4, [%r1]+		; switch(*PC++)
	xsll %r4, 2
	add %r4, %r2
	ld.w %r4, [%r4]
	call %r4

	xsub %r3, %r3, 1		; } while(--count > 0)
	xjrgt spc2cpu_run_L10

	xld.w [%r0+PC], %r1		; cpu->pc = PC

	popn %r3
	ret

;****************************************************************************

;
; 8bitlǂݏo܂B
; [in]
;	%r12		ǂݏoAhXB
; [out]
;	%r10		ǂݏof[^B
; [mod]
;	%r0-3		ۑ
;	%r4-7		j
;	%r8-9		\
;	%r10		߂l
;	%r11		j
;	%r12-15		ۑ
;
	.global spc2cpu_READ
spc2cpu_READ:
	xsub %r10, %r12, 0xf0		; if((unsigned)(addr - 0xf0) > 0xf) {
	xcmp %r10, 0xf
	xjrule spc2cpu_READ_L10
	ext spc2ram@ah			;   return spc2ram[addr]
	ext spc2ram@al
	ld.ub %r10, [%r12]
	ret
spc2cpu_READ_L10:			; } else {
	xsub %sp, %sp, 16
	xld.w [%sp+ 0], %r12
	xld.w [%sp+ 4], %r13
	xld.w [%sp+ 8], %r14
	xld.w [%sp+12], %r15
	xcall spc2drv_read		;   return spc2drv_read(addr)
	xld.w %r12, [%sp+ 0]
	xld.w %r13, [%sp+ 4]
	xld.w %r14, [%sp+ 8]
	xld.w %r15, [%sp+12]
	xadd %sp, %sp, 16
	ret				; }

;****************************************************************************

;
; 8bitl݂܂B
; [in]
;	%r12		ރAhXB
;	%r13		ރf[^B([31:8]͕sł\܂)
; [mod]
;	%r0-3		ۑ
;	%r4-7		j
;	%r8-9		\
;	%r10-11		j
;	%r12-15		ۑ
;
	.global spc2cpu_WRITE
spc2cpu_WRITE:
;;{{SPC2_DEBUG
;;	pushn %r15
;;	xcall spc2cpu_write_trace
;;	popn %r15
;;}}SPC2_DEBUG
	xsub %r10, %r12, 0xf0		; if((unsigned)(addr - 0xf0) > 0xf) {
	xcmp %r10, 0xf
	xjrule spc2cpu_WRITE_L10
	ext spc2ram@ah			;   spc2ram[addr] = data
	ext spc2ram@al
	ld.b [%r12], %r13
	ret
spc2cpu_WRITE_L10:			; } else {
	xsub %sp, %sp, 16
	xld.w [%sp+ 0], %r12
	xld.w [%sp+ 4], %r13
	xld.w [%sp+ 8], %r14
	xld.w [%sp+12], %r15
	xcall spc2drv_write		;   return spc2drv_write(addr, data)
	xld.w %r12, [%sp+ 0]
	xld.w %r13, [%sp+ 4]
	xld.w %r14, [%sp+ 8]
	xld.w %r15, [%sp+12]
	xadd %sp, %sp, 16
	ret				; }

;****************************************************************************

;
; 16bitlǂݏo܂B
; [in]
;	%r12		ǂݏoAhXB
; [out]
;	%r10		ǂݏof[^B
; [mod]
;	%r0-3		ۑ
;	%r4-7		j
;	%r8-9		\
;	%r10		߂l
;	%r11		j
;	%r12-15		ۑ
;
	.global spc2cpu_READW
spc2cpu_READW:
	xsub %sp, %sp, 4

	xcall spc2cpu_READ
	xld.w [%sp+0], %r10

	xadd %r12, %r12, 1
	xcall spc2cpu_READ
	xsub %r12, %r12, 1

	xsll %r10, 8
	xld.w %r11, [%sp+0]
	or %r10, %r11

	xadd %sp, %sp, 4
	ret

;****************************************************************************

;
; 16bitl݂܂B
; [in]
;	%r12		ރAhXB
;	%r13		ރf[^B([31:16]͕sł\܂)
; [mod]
;	%r0-3		ۑ
;	%r4-7		j
;	%r8-9		\
;	%r10-11		j
;	%r12-15		ۑ
;
	.global spc2cpu_WRITEW
spc2cpu_WRITEW:
	xcall spc2cpu_WRITE

	xadd %r12, %r12, 1
	xrr %r13, 8
	xcall spc2cpu_WRITE
	xsub %r12, %r12, 1
	xrl %r13, 8

	ret

;****************************************************************************

;
; L[8bitZs܂B
; [in]
;	%r0	SPC2CPU\́B
;	%r14	鐔B
;	%r15	B
; [out]
;	%r13	ʁB([31:8]͕sł)
; [mod]
;	%r0-7	ۑ
;	%r8-9	\
;	%r10-11	j (݂̎ł͕ۑłÂ߂ɔjƍlĂ)
;	%r12	ۑ
;	%r13	߂l
;	%r14-15	j
;
	.global spc2cpu_ADC
spc2cpu_ADC:
	xld.ub %r13, [%r0+PSW_C]	; tmp = a + b + ((PSW_C & 1) ? 1 : 0)
	xand %r13, %r13, 1
	add %r13, %r14
	add %r13, %r15

	xor %r15, %r14			; PSW_V = ~(a ^ b) & (a ^ tmp)
	not %r15, %r15
	xor %r14, %r13
	and %r14, %r15
	xld.b [%r0+PSW_V], %r14

	xld.h [%r0+PSW_CNZ], %r13	; PSW_CNZ = tmp

	ret

;
; L[8bitZs܂B
; [in]
;	%r0	SPC2CPU\́B
;	%r14	鐔B
;	%r15	B
; [out]
;	%r13	ʁB([31:8]͕sł)
; [mod]
;	%r0-7	ۑ
;	%r8-9	\
;	%r10-11	j (݂̎ł͕ۑłÂ߂ɔjƍlĂ)
;	%r12	ۑ
;	%r13	߂l
;	%r14-15	j
;
	.global spc2cpu_SBC
spc2cpu_SBC:
	xld.ub %r13, [%r0+PSW_C]	; tmp = a - b + ((PSW_C & 1) ? 0 : -1)
	xand %r13, %r13, 1
	xsub %r13, %r13, 1
	add %r13, %r14
	sub %r13, %r15

	xor %r15, %r14			; PSW_V = (a ^ b) & (a ^ tmp)
	xor %r14, %r13
	and %r14, %r15
	xld.b [%r0+PSW_V], %r14

	xxor %r13, %r13, 0x100		; PSW_CNZ = tmp ^ 0x100
	xld.h [%r0+PSW_CNZ], %r13

	ret

;
; L[16bitZs܂B
; [in]
;	%r0	SPC2CPU\́B
;	%r14	鐔B
;	%r15	B
; [out]
;	%r13	ʁB([31:16]͕sł)
; [mod]
;	%r0-7	ۑ
;	%r8-9	\
;	%r10-11	j (݂̎ł͕ۑłÂ߂ɔjƍlĂ)
;	%r12	ۑ
;	%r13	߂l
;	%r14-15	j
;
	.global spc2cpu_ADDW
spc2cpu_ADDW:
	ld.w %r13, %r14			; tmp = a + b
	add %r13, %r15

	xor %r15, %r14			; PSW_V = (~(a ^ b) & (a ^ tmp)) >> 8
	not %r15, %r15
	xor %r14, %r13
	and %r14, %r15
	xsrl %r14, 8
	xld.b [%r0+PSW_V], %r14

	ld.w %r14, %r13			; PSW_CNZ = (tmp >> 8) | ((unsigned short)tmp != 0)
	xand %r15, %r13, 0xffff
	jreq.d 3
	srl %r14, 8			; *delay*
	or %r14, 1
	xld.h [%r0+PSW_CNZ], %r14

	ret

;
; L[16bitZs܂B
; [in]
;	%r0	SPC2CPU\́B
;	%r14	鐔B
;	%r15	B
; [out]
;	%r13	ʁB([31:16]͕sł)
; [mod]
;	%r0-7	ۑ
;	%r8-9	\
;	%r10-11	j (݂̎ł͕ۑłÂ߂ɔjƍlĂ)
;	%r12	ۑ
;	%r13	߂l
;	%r14-15	j
;
	.global spc2cpu_SUBW
spc2cpu_SUBW:
	ld.w %r13, %r14			; tmp = a - b
	sub %r13, %r15

	xor %r15, %r14			; PSW_V = ((a ^ b) & (a ^ tmp)) >> 8
	xor %r14, %r13
	and %r14, %r15
	xsrl %r14, 8
	xld.b [%r0+PSW_V], %r14

	ld.w %r14, %r13			; PSW_CNZ = ((tmp >> 8) | ((unsigned short)tmp != 0)) ^ 0x100
	xand %r15, %r13, 0xffff
	jreq.d 3
	srl %r14, 8			; *delay*
	or %r14, 1
	xxor %r14, %r14, 0x100
	xld.h [%r0+PSW_CNZ], %r14

	ret

;
; [tO1ȂΕ򂵂܂B
; [in]
;	%r0		SPC2CPU\́B
;	%r1		PCB
;	%psr(Z)		1ȂΕ򂵂܂B
;			0ȂΕ򂵂܂B
; [out]
;	%r1		XVꂽPCB
; [mod]
;	%r0-7	ۑ
;	%r8-9	\
;	%r10-11	j	(RELATIVE%r10jB%r11͍̂߂ɔjƍlĂ)
;	%r12-15	ۑ
;
	.global spc2cpu_BEQ
spc2cpu_BEQ:
	xjreq spc2cpu_BEQ_L10		; if(!EQ) {
	ret.d				;   PC++
	add %r1, 1			;   *delay*
spc2cpu_BEQ_L10:			; } else {
	RELATIVE			;   RELATIVE
	ret				; }

;
; [tO0ȂΕ򂵂܂B
; [in]
;	%r0		SPC2CPU\́B
;	%r1		PCB
;	%psr(Z)		0ȂΕ򂵂܂B
;			1ȂΕ򂵂܂B
; [out]
;	%r1		XVꂽPCB
; [mod]
;	%r0-7	ۑ
;	%r8-9	\
;	%r10-11	j	(RELATIVE%r10jB%r11͍̂߂ɔjƍlĂ)
;	%r12-15	ۑ
;
	.global spc2cpu_BNE
spc2cpu_BNE:
	xjrne spc2cpu_BNE_L10		; if(!NE) {
	ret.d				;   PC++
	add %r1, 1			;   *delay*
spc2cpu_BNE_L10:			; } else {
	RELATIVE			;   RELATIVE
	ret				; }

;****************************************************************************
;	SPC2DSP
;****************************************************************************

	.global spc2vce_mix
spc2vce_mix:
	pushn %r3
	xsub %sp, %sp, 16
	; %r12 = vce
	; %r13 = mixbuf

	xbtst [%r12+KON], 0
	xjreq spc2vce_mix_EXIT		; KeyOff

	xld.w %r14, spc2dsp		; dsp = &spc2dsp
	; %r14 = dsp

	; C{[~`l{[߂܂B
	xld.w %r10, [%r14+MVOL]		; vol = (dsp->mvol * vce->vol) >> 6
	xld.w %r11, [%r12+VOL]
	mlt.h %r10, %r11
	ld.w %r15, %alr
	xsrl %r15, 6
	xjreq spc2vce_mix_EXIT		; {[0AقƂǃ[
	; %r15 = vol

	; ̂߁ApɂɎgtB[hoĂ܂B
	xld.w %r0, [%r12+PROGRESS]	; vce->progress
	xld.w %r1, [%r12+P]		; vce->p
	xadd %r2, %r12, SAMPLE		; vce->sample
	; %r0 = progress
	; %r1 = p
	; %r2 = sample

	xld.w %r3, 64			; for(i = 0; i < 64; i++) {
	; %r3 = i
spc2vce_mix_L10:
	add %r0, %r1			; progress += p

spc2vce_mix_L20:
	xcmp %r0, 16<<11		; while(progress >= 16 << 11) {
	xjrlt spc2vce_mix_L30
	xsub %r0, %r0, 16<<11		; progress -= 16 << 11

	xbtst [%r12+LAST_LOOP], 0	; if(vce->last_loop & 1) { /* ŏIubN */
	xjreq spc2vce_mix_L40
	xbtst [%r12+LAST_LOOP], 1	; if(!(vce->last_loop & 2)) { /* [vȂF */
	xjrne spc2vce_mix_L50

	xld.w [%r12+KON], %r8		; vce->kon = 0
	xjp spc2vce_mix_EXIT		; return

spc2vce_mix_L50:			; } else { /* [vF */
	xld.w %r10, [%r14+DIR]		; dsp->dir
	xld.w %r11, [%r12+SRCN]		; vce->srcn
	add %r10, %r11			; dsp->dir + vce->srcn
	ext spc2ram+2@ah		; memp = &spc2ram[(dsp->dir + vce->srcn) + 2/*Source Loop Start Address*/]
	ext spc2ram+2@al		; (ext33"xadd %rd,%rs,addr"WJłȂ)
	add %r11, %r10
	ld.ub %r10, [%r11]+		; memp[0]
	ld.ub %r11, [%r11]		; memp[1]
	xsll %r11, 8			; vce->brr_addr = memp[0] | memp[1] << 8
	or %r10, %r11
	xld.w [%r12+BRR_ADDR], %r10
	; FALLTHRU

spc2vce_mix_L40:			; } /* if */
	xld.w [%sp+ 0], %r12
	xld.w [%sp+ 4], %r13
	xld.w [%sp+ 8], %r14
	xld.w [%sp+12], %r15
	xcall spc2vce_decode_brr	; spc2vce_decode_brr(vce)
	xld.w %r12, [%sp+ 0]
	xld.w %r13, [%sp+ 4]
	xld.w %r14, [%sp+ 8]
	xld.w %r15, [%sp+12]
	xjp spc2vce_mix_L20

spc2vce_mix_L30:			; } /* while */
	ld.w %r10, [%r13]		; *mixbuf
	ld.w %r11, %r0			; sample[progress >> 11]
	xsrl %r11, 11-1
	xand %r11, %r11, ~1
	add %r11, %r2
	ld.h %r11, [%r11]
	mlt.h %r11, %r15		; sample[progress >> 11] * vol
	ld.w %r11, %alr
	add %r10, %r11			; *mixbuf++ += (sample[progress >> 11] * vol)
	ld.w [%r13]+, %r10

	xsub %r3, %r3, 1		; } /* for */
	xjrne spc2vce_mix_L10

	; isJE^߂BYȂ!!
	xld.w [%r12+PROGRESS], %r0	; vce->progress

spc2vce_mix_EXIT:
	xadd %sp, %sp, 16
	popn %r3
	ret

;****************************************************************************

	.global spc2vce_decode_brr
spc2vce_decode_brr:
	pushn %r1
	; %r12 = vce

	; kf[^AWJobt@|C^擾B
	xadd %r13, %r12, SAMPLE		; dst = vce->sample
	xld.w %r14, [%r12+BRR_ADDR]	; BRRubNAhXi߂Ă܂B
	xadd %r10, %r14, 9
	xld.w [%r12+BRR_ADDR], %r10
	ext spc2ram@ah			; src = &spc2ram[vce->brr_addr]
	ext spc2ram@al			; (ext33"xadd %rd,%rs,addr"WJłȂ)
	add %r14, %r14
	; %r13 = dst
	; %r14 = src

	; wb_ǂݏoAi[B
	ld.ub %r15, [%r14]+		; header = *src++
	xld.w [%r12+LAST_LOOP], %r15	; vce->last_loop = header
	; %r15 = header

	; tB^W擾B
	xand %r10, %r15, 3<<2		; f = spc2dsp_filter_table[(header >> 2) & 3]
	ext spc2dsp_filter_table@ah	; (ext33"xadd %rd,%rs,addr"WJłȂ)
	ext spc2dsp_filter_table@al
	add %r10, %r10
	ld.h %r4, [%r10]+		; f1 = f[0]
	ld.h %r5, [%r10]		; f2 = f[1]
	; %r4 = f1
	; %r5 = f1

	; XP[OW擾B
	xsrl %r15, 4			; range = header >> 4
	; %r15 = range

	xld.h %r6, [%r13+(16-1)*2]	; prev1 = vce->sample[16 - 1] /* 1ÕTv */
	xld.h %r7, [%r13+(16-2)*2]	; prev2 = vce->sample[16 - 2] /* 2ÕTv */
	; %r6 = prev1
	; %r7 = prev2

	xld.w %r12, 8			; for(i = 0; i < 8; i++) {
	; %r12 = i
spc2vce_decode_brr_L10:

	ld.b %r0, [%r14]+		; ..._ssssssss_hhhhllll,s=h[MSB]
	xsll %r0, 4			; ..._sssshhhh_llll0000
	ld.b %r1, %r0			; ..._tttttttt_llll0000,t=l[MSB]
	xsra %r0, 8			; ..._ssssssss_sssshhhh => data1 /* ʃju */
	xsra %r1, 4			; ..._tttttttt_ttttllll => data2 /* ʃju */
	; %r0 = data1
	; %r1 = data2

	; sTv𕜍B
	mlt.h %r6, %r4			; prev1 * f1
	ld.w %r10, %alr
	mlt.h %r7, %r5			; prev2 * f2
	ld.w %r11, %alr
	sub %r10, %r11			; (prev1 * f1) - (prev2 * f2)
	xsra %r10, 8			; ((prev1 * f1) - (prev2 * f2)) >> 8
	xsll %r0, %r15			; data1 << range
	add %r0, %r10			; (data1 << range) + (((prev1 * f1) - (prev2 * f2)) >> 8)
	xcmp %r0, -0x7fff		; if(data1 < -0x7fff) data1 = -0x7fff
	xjrge spc2vce_decode_brr_L20
	xld.w %r0, -0x7fff
spc2vce_decode_brr_L20:
	xcmp %r0, 0x7fff		; if(data1 >  0x7fff) data1 =  0x7fff
	xjrle spc2vce_decode_brr_L30
	xld.w %r0, 0x7fff
spc2vce_decode_brr_L30:
	ld.h [%r13]+, %r0		; *dst++ = data1
	ld.w %r7, %r6			; prev2 = prev1
	ld.w %r6, %r0			; prev1 = data1

	; sTv𕜍B
	mlt.h %r6, %r4			; prev1 * f1
	ld.w %r10, %alr
	mlt.h %r7, %r5			; prev2 * f2
	ld.w %r11, %alr
	sub %r10, %r11			; (prev1 * f1) - (prev2 * f2)
	xsra %r10, 8			; ((prev1 * f1) - (prev2 * f2)) >> 8
	xsll %r1, %r15			; data2 << range
	add %r1, %r10			; (data2 << range) + (((prev1 * f1) - (prev2 * f2)) >> 8)
	xcmp %r1, -0x7fff		; if(data2 < -0x7fff) data2 = -0x7fff
	xjrge spc2vce_decode_brr_L40
	xld.w %r1, -0x7fff
spc2vce_decode_brr_L40:
	xcmp %r1, 0x7fff		; if(data2 >  0x7fff) data2 =  0x7fff
	xjrle spc2vce_decode_brr_L50
	xld.w %r1, 0x7fff
spc2vce_decode_brr_L50:
	ld.h [%r13]+, %r1		; *dst++ = data2
	ld.w %r7, %r6			; prev2 = prev1
	ld.w %r6, %r1			; prev1 = data2

	xsub %r12, %r12, 1		; } /* for */
	xjrne spc2vce_decode_brr_L10

	popn %r1
	ret

;****************************************************************************

#endif ;/*SPC2_ASM*/
